! *****************************************************************************
! *****************************************************************************

SUBROUTINE MAKESTATEFILE(ErrStatus, WHandle, FName, LkName)
   USE MakeStateFile_Main, ONLY : DO_MakeStateFile

   IMPLICIT    NONE
   INTEGER, INTENT(INOUT)  :: WHandle
   INTEGER, INTENT(INOUT)  :: ErrStatus              !  0=OK,  otherwise an error
   CHARACTER (LEN=*), INTENT(IN) :: FName, LkName

 !GCC$ ATTRIBUTES CDECL, DLLEXPORT ::  MAKESTATEFILE

   CALL DO_MakeStateFile(ErrStatus, WHandle, FName, LkName)

END SUBROUTINE MAKESTATEFILE


! *****************************************************************************
! *****************************************************************************

SUBROUTINE NEWFRCST(ErrStatus, WHandle, LkName)
   USE NewFcstMain, ONLY : DO_NEWFRCST

   IMPLICIT    NONE
   INTEGER, INTENT(INOUT)  :: WHandle
   INTEGER, INTENT(INOUT)  :: ErrStatus              !  0=OK,  otherwise an error
   CHARACTER (LEN=*), INTENT(IN) :: LkName

 !GCC$ ATTRIBUTES CDECL, DLLEXPORT ::  NEWFRCST

   CALL DO_NEWFRCST(ErrStatus, WHandle, LkName)

END SUBROUTINE NEWFRCST


! *****************************************************************************
! *****************************************************************************

SUBROUTINE FRCST (ErrStatus, WHandle, LkName)
   USE FrcstMain, ONLY : DO_FRCST

   IMPLICIT    NONE
   INTEGER, INTENT(INOUT)  :: WHandle
   INTEGER, INTENT(INOUT)  :: ErrStatus              !  0=OK,  otherwise an error
   CHARACTER (LEN=*), INTENT(IN) :: LkName

 !GCC$ ATTRIBUTES CDECL, DLLEXPORT ::  FRCST

   CALL DO_FRCST(ErrStatus, WHandle, LkName)

END SUBROUTINE FRCST


! *****************************************************************************
! *****************************************************************************

SUBROUTINE CPFFUOPM (EvpRun, ErrStatus, WHandle, LkName)
   USE CPF_Main, ONLY : DO_CPF

   IMPLICIT    NONE
   INTEGER, INTENT(INOUT)  :: WHandle
   INTEGER, INTENT(INOUT)  :: EvpRun                 !  0=evap data;  1=runoff data
   INTEGER, INTENT(INOUT)  :: ErrStatus              !  0=OK,  otherwise an error
   CHARACTER (LEN=*), INTENT(IN) :: LkName

 !GCC$ ATTRIBUTES CDECL, DLLEXPORT ::  CPFFUOPM

   CALL DO_CPF(EvpRun, ErrStatus, WHandle, LkName)

END SUBROUTINE CPFFUOPM

! *****************************************************************************
! *****************************************************************************

SUBROUTINE XEVAPOUT (ErrStatus, WHandle, LkName)
   USE XEvapMain, ONLY : DO_XEVAP

   IMPLICIT    NONE
   INTEGER, INTENT(INOUT)  :: WHandle
   INTEGER, INTENT(INOUT)  :: ErrStatus              !  0=OK,  otherwise an error
   CHARACTER (LEN=*), INTENT(IN) :: LkName

 !GCC$ ATTRIBUTES CDECL, DLLEXPORT ::  XEVAPOUT

   CALL DO_XEVAP(ErrStatus, WHandle, LkName)

END SUBROUTINE XEVAPOUT


! *****************************************************************************
! *****************************************************************************

SUBROUTINE AHPS_TO_LBRM (ErrStatus, WHandle, PrvFcst, Sub, LkName)
   USE LBRM_Files

   IMPLICIT    NONE
   INTEGER, INTENT(INOUT)  :: WHandle
   INTEGER, INTENT(INOUT)  :: ErrStatus       !  0=OK,  otherwise an error
   INTEGER, INTENT(INOUT)  :: PrvFcst         ! 1=provisional period, 2=forecast period
   INTEGER, INTENT(INOUT)  :: Sub
   CHARACTER (LEN=*), INTENT(IN) :: LkName

 !GCC$ ATTRIBUTES CDECL, DLLEXPORT ::  AHPS_TO_LBRM

   CALL AHPS2LBRM(ErrStatus, WHandle, PrvFcst, Sub, LkName)

END SUBROUTINE AHPS_TO_LBRM

! *****************************************************************************
! *****************************************************************************

SUBROUTINE LBRM_TO_AHPS (ErrStatus, WHandle, PrvFcst, Sub, LkName)
   USE LBRM_Files, ONLY : LBRM2AHPS

   IMPLICIT    NONE
   INTEGER, INTENT(INOUT)  :: WHandle
   INTEGER, INTENT(INOUT)  :: ErrStatus       !  0=OK,  otherwise an error
   INTEGER, INTENT(INOUT)  :: PrvFcst         ! 1=provisional period, 2=forecast period
   INTEGER, INTENT(INOUT)  :: Sub
   CHARACTER (LEN=*), INTENT(IN) :: LkName

 !GCC$ ATTRIBUTES CDECL, DLLEXPORT ::  LBRM_TO_AHPS

   CALL LBRM2AHPS(ErrStatus, WHandle, PrvFcst, Sub, LkName)

END SUBROUTINE LBRM_TO_AHPS

! *****************************************************************************
! *****************************************************************************

SUBROUTINE LUMPSTOR (ErrStatus, WHandle, LkName)
   USE LumpStorMain, ONLY : DO_LUMPSTOR

   IMPLICIT    NONE
   INTEGER, INTENT(INOUT)  :: WHandle
   INTEGER, INTENT(INOUT)  :: ErrStatus              !  0=OK,  otherwise an error
   CHARACTER (LEN=*), INTENT(IN) :: LkName

 !GCC$ ATTRIBUTES CDECL, DLLEXPORT ::  LUMPSTOR

   CALL DO_LUMPSTOR(ErrStatus, WHandle, LkName)

END SUBROUTINE LUMPSTOR


! *****************************************************************************
! *****************************************************************************

SUBROUTINE EXTRACTSUBFLW (ErrStatus, WHandle, LkName)
   USE ExtractSubFlwMain, ONLY : DO_GETSUBFLW

   IMPLICIT    NONE
   INTEGER, INTENT(INOUT)  :: WHandle
   INTEGER, INTENT(INOUT)  :: ErrStatus              !  0=OK,  otherwise an error
   CHARACTER (LEN=*), INTENT(IN) :: LkName

 !GCC$ ATTRIBUTES CDECL, DLLEXPORT ::  EXTRACTSUBFLW

   CALL DO_GETSUBFLW(ErrStatus, WHandle, LkName)

END SUBROUTINE EXTRACTSUBFLW


! *****************************************************************************
! *****************************************************************************

SUBROUTINE AHPS_ArrSizes(ErrStatus, WHandle, PF, Sub, BoundCond, DaysOfSim, Bsn)

   USE LBRM_Files

   IMPLICIT NONE
   INTEGER, INTENT(INOUT)  :: ErrStatus     !  0=OK,  otherwise an error
   INTEGER, INTENT(INOUT)  :: WHandle, PF, Sub
   INTEGER, INTENT(INOUT)  :: BoundCond, DaysOfSim
   CHARACTER (LEN=*), INTENT(IN) :: Bsn

 !GCC$ ATTRIBUTES CDECL, DLLEXPORT ::  AHPS_ArrSizes

   WinHandle = WHandle
   ErrorLevel = 0

   CALL AHPS_FindArraySizes(PF, Sub, Bsn, DaysOfSim, BoundCond); IF (ErrorLevel .NE. 0) GOTO 99

99 ErrStatus = ErrorLevel

END SUBROUTINE AHPS_ArrSizes

! *****************************************************************************
! *****************************************************************************

SUBROUTINE AHPS_ReadData(ErrStatus, WHandle, PF,Sub, BCnt, DCnt, BCSeqs,      &
  &                      BCU, BCL, BCG, BCS, BCN, Mx, Mn, MP, Lake)

   USE LBRM_Files

   IMPLICIT  NONE
   INTEGER, INTENT(INOUT)  :: ErrStatus     !  0=OK,  otherwise an error
   INTEGER, INTENT(INOUT)  :: WHandle
   INTEGER, INTENT(INOUT)  :: PF, Sub, BCnt, DCnt
   INTEGER (KIND=INTEGER2), DIMENSION(DCnt), INTENT(INOUT) :: Mx, Mn, MP
   INTEGER, DIMENSION(BCnt), INTENT(INOUT) :: BCSeqs
   REAL,    DIMENSION(BCnt), INTENT(INOUT) :: BCU, BCL, BCG, BCS, BCN
   CHARACTER (LEN=*), INTENT(IN) :: Lake

 !GCC$ ATTRIBUTES CDECL, DLLEXPORT ::  AHPS_ReadData

   WinHandle = WHandle
   ErrorLevel = 0

   CALL AHPSInputData(PF,Sub,Lake,BCnt,DCnt, BCSeqs, BCU,BCL,BCG,BCS,BCN, Mx,Mn,MP)

   ErrStatus = ErrorLevel

END SUBROUTINE AHPS_ReadData

! *****************************************************************************
! *****************************************************************************

SUBROUTINE LBRM_ArraySizes(ErrStatus, WHandle, BoundCond, DaysOfSim)

   USE LBRM_MAIN

   IMPLICIT NONE
   INTEGER, INTENT(INOUT)  :: ErrStatus     !  0=OK,  otherwise an error
   INTEGER, INTENT(INOUT)  :: WHandle
   INTEGER, INTENT(INOUT)  :: BoundCond, DaysOfSim

 !GCC$ ATTRIBUTES CDECL, DLLEXPORT ::  LBRM_ArraySizes

   WinHandle = WHandle
   ErrorLevel = 0

   CALL ReadLBRMCFGfile;                      IF (ErrorLevel .NE. 0) GOTO 99
   CALL FindArraySizes(DaysOfSim, BoundCond); IF (ErrorLevel .NE. 0) GOTO 99

99 ErrStatus = ErrorLevel

END SUBROUTINE LBRM_ArraySizes

! *****************************************************************************
! *****************************************************************************

SUBROUTINE LBRM_Guts(ErrStatus, WHandle, cCons, BCnt, DCnt,              &
  &                  BCSeqs, BCU, BCL, BCG, BCS, BCN,                    &
  &                  Mx, Mn, MP, ORn, OUz, OLz, OGz, OSz, OSn,           &
  &                  LT1, LT2, LT3, LT4, LT5, LT6)

   USE LBRM_Main

   IMPLICIT  NONE
   INTEGER, INTENT(INOUT)  :: ErrStatus     !  0=OK,  otherwise an error
   INTEGER, INTENT(INOUT)  :: WHandle
   INTEGER, INTENT(INOUT)  :: BCnt, DCnt
   REAL, INTENT(INOUT)     :: cCons
   INTEGER (KIND=INTEGER2), DIMENSION(DCnt), INTENT(INOUT) :: Mx, Mn, MP
   INTEGER, DIMENSION(BCnt), INTENT(INOUT) :: BCSeqs
   REAL,    DIMENSION(BCnt), INTENT(INOUT) :: BCU, BCL, BCG, BCS, BCN
   REAL,    DIMENSION(DCnt), INTENT(INOUT) :: ORn, OUz, OLz, OGz, OSz, OSn
   REAL,    INTENT(INOUT) :: LT1, LT2, LT3, LT4, LT5, LT6

 !GCC$ ATTRIBUTES CDECL, DLLEXPORT ::  LBRM_Guts

   WinHandle = WHandle
   ErrorLevel = 0

   iNoDataPoints = DCnt
   iNoBC = BCnt

   UseAhpsCfg = .FALSE.
   AhpsCfgFile = ''

   CALL ReadLBRMCfgFile;          IF (ErrorLevel .NE. 0) GOTO 99
   CALL ReadParameterFile;        IF (ErrorLevel .NE. 0) GOTO 99

   NumBC = BCnt
   CALL LBRM_Engine(cCons, BCnt, DCnt,                             &
  &                 BCSeqs, BCU, BCL, BCG, BCS, BCN,               &
  &                 Mx, Mn, MP, ORn, OUz, OLz, OGz, OSz, OSn,      &
  &                 LT1, LT2, LT3, LT4, LT5, LT6)

99 ErrStatus = ErrorLevel

END SUBROUTINE LBRM_Guts

! *****************************************************************************
! *****************************************************************************

SUBROUTINE LBRM_ReadData(ErrStatus, WHandle, BCnt, DCnt, BCSeqs,      &
  &                      BCU, BCL, BCG, BCS, BCN, Mx, Mn, MP)

   USE LBRM_Main

   IMPLICIT  NONE
   INTEGER, INTENT(INOUT)  :: ErrStatus     !  0=OK,  otherwise an error
   INTEGER, INTENT(INOUT)  :: WHandle
   INTEGER, INTENT(INOUT)  :: BCnt, DCnt
   INTEGER (KIND=INTEGER2), DIMENSION(DCnt), INTENT(INOUT) :: Mx, Mn, MP
   INTEGER, DIMENSION(BCnt), INTENT(INOUT) :: BCSeqs
   REAL,    DIMENSION(BCnt), INTENT(INOUT) :: BCU, BCL, BCG, BCS, BCN

 !GCC$ ATTRIBUTES CDECL, DLLEXPORT ::  LBRM_ReadData

   WinHandle = WHandle
   ErrorLevel = 0

   iNoDataPoints = DCnt
   iNoBC = BCnt
   CALL InputLBRMdata(BCnt,DCnt, BCSeqs, BCU,BCL,BCG,BCS,BCN, Mx,Mn,MP)
 
   ErrStatus = ErrorLevel

END SUBROUTINE LBRM_ReadData

! *****************************************************************************
! *****************************************************************************

SUBROUTINE LBRM_WriteData(ErrStatus, WHandle, DCnt,                   &
  &                       ORun, OUsz, OLsz, OGzm, OSrf, OSnw)

   USE LBRM_Main

   IMPLICIT  NONE
   INTEGER, INTENT(INOUT)  :: ErrStatus     !  0=OK,  otherwise an error
   INTEGER, INTENT(INOUT)  :: WHandle
   INTEGER, INTENT(INOUT)  :: DCnt
   REAL, DIMENSION(DCnt), INTENT(INOUT) :: ORun, OUsz, OLsz
   REAL, DIMENSION(DCnt), INTENT(INOUT) :: OGzm, OSrf, OSnw

 !GCC$ ATTRIBUTES CDECL, DLLEXPORT ::  LBRM_WriteData

   WinHandle = WHandle
   ErrorLevel = 0

   iNoDataPoints = DCnt
   CALL WriteLBRMOutputFile(ORun, OUsz, OLsz, OGzm, OSrf, OSnw)
   ErrStatus = ErrorLevel

END SUBROUTINE LBRM_WriteData


! *****************************************************************************
! *****************************************************************************

SUBROUTINE WriteLBRMArraysToAHPS(ErrStatus, WHandle, PF, Sub, DS,              &
   &                             ORun, OUsz, OLsz, OGzm, OSrf, OSnw, Lake)

   USE LBRM_Files

   IMPLICIT  NONE
   INTEGER, INTENT(INOUT)  :: ErrStatus     !  0=OK,  otherwise an error
   INTEGER, INTENT(INOUT)  :: WHandle
   INTEGER, INTENT(INOUT)  :: PF, Sub, DS
   REAL, DIMENSION(DS), INTENT(INOUT) :: ORun, OUsz, OLsz
   REAL, DIMENSION(DS), INTENT(INOUT) :: OGzm, OSrf, OSnw
   CHARACTER (LEN=3), INTENT(IN) :: Lake

 !GCC$ ATTRIBUTES CDECL, DLLEXPORT ::  WriteLBRMArraysToAHPS

   WinHandle = WHandle
   ErrorLevel = 0

   CALL LBRM2AHPSWriteOnly(ErrStatus, WHandle, PF, Sub, DS, ORun, OUsz,        &
   &                       OLsz, OGzm, OSrf, OSnw, Lake)
   ErrStatus = ErrorLevel

END SUBROUTINE WriteLBRMArraysToAHPS


