c
c  This program shortens CLM files for a specified lake.
c
      IMPLICIT   NONE
      INTEGER*2  IDUM, ITMAX, ITMIN, IPREC, I1,I2,I3,I4
      INTEGER*4  I, J, K, SEQNUM, StartSeq, EndSeq, ID, IM, IY
      INTEGER*4  SYR, EYR, SUBS, IOS
      CHARACTER*2   SB
      CHARACTER*3   BSN
      CHARACTER*4   CYEAR, CY1, CY2
      CHARACTER*12  FILEIN, FILEOUT
      CHARACTER*80  CLine

C
C  ENTER FILE SPECS
C
      CALL GETCL(CLine)
      CALL ParseCL(CLine, Bsn, CY1, CY2)

      IF (Bsn .NE. 'xxx') GOTO 11
      PRINT*, 'PLEASE ENTER THE BASIN NAME (3-CHAR) :'
 10   READ(*, 1000) BSN
 11   SUBS = 0
      CALL Caps(Bsn, 3)
      IF (BSN .EQ. 'SUP') SUBS = 22
      IF (BSN .EQ. 'MIC') SUBS = 27
      IF (BSN .EQ. 'HUR') SUBS = 16
      IF (BSN .EQ. 'GEO') SUBS = 13
      IF (BSN .EQ. 'STC') SUBS = 7
      IF (BSN .EQ. 'ERI') SUBS = 21
      IF (BSN .EQ. 'ONT') SUBS = 15
      IF (SUBS .EQ. 0) THEN
        PRINT*, 'INVALID BASIN NAME - REENTER : '
        GOTO 10
      ENDIF

C
C  ENTER YEAR RANGE
C
      CYEAR = CY1
      IF (CY1 .NE. '0000') GOTO 17
 15   PRINT*, 'PLEASE ENTER THE STARTING YEAR (4-CHAR): '
 16   READ(*, 1001) CYEAR
 17   IY = ICHAR(CYEAR(1:1)) - 48
      IY = IY*10 + ICHAR(CYEAR(2:2)) - 48
      IY = IY*10 + ICHAR(CYEAR(3:3)) - 48
      IY = IY*10 + ICHAR(CYEAR(4:4)) - 48
      IF ((IY .GT. 2049) .OR. (IY .LT. 1800)) THEN
         PRINT*, 'INVALID YEAR - REENTER: '
         GOTO 16
      ENDIF
      SYR = IY

      CYEAR = CY2
      IF (CY2 .NE. '0000') GOTO 27
 25   PRINT*, 'PLEASE ENTER THE ENDING YEAR (4-CHAR): '
 26   READ(*, 1001) CYEAR
 27   IY = ICHAR(CYEAR(1:1)) - 48
      IY = IY*10 + ICHAR(CYEAR(2:2)) - 48
      IY = IY*10 + ICHAR(CYEAR(3:3)) - 48
      IY = IY*10 + ICHAR(CYEAR(4:4)) - 48
      IF ((IY .GT. 2049) .OR. (IY .LT. 1800)) THEN
         PRINT*, 'INVALID YEAR - REENTER : '
         GOTO 26
      ENDIF
      EYR = IY

C
C  MAIN LOOP
C
      DO 200, J = 0, SUBS
        SB(1:1) = CHAR(J/10+48)
        SB(2:2) = CHAR(J-(J/10*10)+48)

C
C    OPEN FILES
C
        FILEIN = BSN//SB//'.CLM'
        OPEN(UNIT=11, FILE=TRIM(FileIn), STATUS='OLD', ACCESS='DIRECT',         &
     &       RECL=6, FORM='UNFORMATTED', IOSTAT=IOS)
        IF (IOS .NE. 0) THEN
           PRINT*, 'Error opening input CLM file - '//TRIM(FileIn)
           CALL EXIT(1)
        END IF

        FILEOUT = BSN//SB//'.CSH'
        OPEN(UNIT=12, FILE=TRIM(FileOut), STATUS='REPLACE', ACCESS='DIRECT',    &
     &       RECL=6, FORM='UNFORMATTED', IOSTAT=IOS)
        IF (IOS .NE. 0) THEN
           PRINT*, 'Error opening output CSH file - '//TRIM(FileOut)
           CALL EXIT(1)
        END IF

c
c    Read header info
c
        READ(11, REC=1) IDUM, StartSeq
        READ(11, REC=2) EndSeq


c
c    Write new header
c
        CALL DATESEQUENCE(1, 1, SYR, SEQNUM)
        K = MAX(SeqNum, StartSeq)
        WRITE(12, REC=1) IDUM, K

        CALL DATESEQUENCE(31, 12, EYR, SEQNUM)
        K = MIN(SeqNum, EndSeq)
        WRITE(12, REC=2) K

c
c    Read/write daily data
c
        K = 0
        DO 100, I = StartSeq, EndSeq
          CALL SEQUENCEDATE(ID, IM, IY, I)
          IF ((IY .GE. SYR) .AND. (IY .LE. EYR)) THEN
             READ(11, REC=(I-StartSeq+1)+2) ITMIN, ITMAX, IPREC
             K = K+1
             WRITE(12, REC=K+2) ITMIN, ITMAX, IPREC
          ENDIF
  100   CONTINUE
        CLOSE(11)
        CLOSE(12)

  200 CONTINUE


C
C    Now process the xxxMD.CLM file
C
C    OPEN FILES
C
      FileIn = BSN//'MD.CLM'
      OPEN(UNIT=11, FILE=TRIM(FileIn), STATUS='OLD', ACCESS='DIRECT',           &
     &     RECL=8, FORM='UNFORMATTED', IOSTAT=IOS)
      IF (IOS .NE. 0) THEN
         PRINT*, 'Error opening input CLM file - '//TRIM(FileIn)
         CALL EXIT(1)
      END IF

      FileOut = BSN//'MD.CSH'
      OPEN(UNIT=12, FILE=TRIM(FileOut), STATUS='REPLACE', ACCESS='DIRECT',      &
     &     RECL=8, FORM='UNFORMATTED', IOSTAT=IOS)
      IF (IOS .NE. 0) THEN
         PRINT*, 'Error opening output CSH file - '//TRIM(FileOut)
         CALL EXIT(1)
      END IF

c
c    Read header info
c
      READ(11, REC=1) IDUM, StartSeq
      READ(11, REC=2) EndSeq

c
c    Write new header
c
      CALL DATESEQUENCE(1, 1, SYR, SEQNUM)
      K = MAX(SeqNum, StartSeq)
      WRITE(12, REC=1) IDUM, K

      CALL DATESEQUENCE(31, 12, EYR, SEQNUM)
      K = MIN(SeqNum, EndSeq)
      WRITE(12, REC=2) K

c
c    Read/write daily data
c
      K = 0
      DO 300, I = StartSeq, EndSeq
        CALL SEQUENCEDATE(ID, IM, IY, I)
        IF ((IY .GE. SYR) .AND. (IY .LE. EYR)) THEN
           READ(11, REC=(I-StartSeq+1)+2) I1, I2, I3, I4
           K = K+1
           WRITE(12, REC=K+2) I1, I2, I3, I4
        ENDIF
  300 CONTINUE
      CLOSE(11)
      CLOSE(12)

C
C    Now process the xxxALL.MET file
C
C    OPEN FILES
C
      FILEIN = BSN//'ALL.MET'
      OPEN(UNIT=11, FILE=TRIM(FileIn), STATUS='OLD', ACCESS='DIRECT',        &
     &     RECL=6, FORM='UNFORMATTED', IOSTAT=IOS)
      IF (IOS .NE. 0) THEN
         PRINT*, 'Error opening input CLM file - '//TRIM(FileIn)
         CALL EXIT(1)
      END IF

      FILEOUT = BSN//'ALL.CSH'
      OPEN(UNIT=12, FILE=TRIM(FileOut), STATUS='REPLACE', ACCESS='DIRECT',   &
     &     RECL=6, FORM='UNFORMATTED', IOSTAT=IOS)
      IF (IOS .NE. 0) THEN
         PRINT*, 'Error opening output CSH file - '//TRIM(FileOut)
         CALL EXIT(1)
      END IF

c
c    Read header info
c
      READ(11, REC=1) IDUM, StartSeq
      READ(11, REC=2) EndSeq

c
c    Write new header
c
      CALL DATESEQUENCE(1, 1, SYR, SEQNUM)
      K = MAX(SeqNum, StartSeq)
      WRITE(12, REC=1) IDUM, K

      CALL DATESEQUENCE(31, 12, EYR, SEQNUM)
      K = MIN(SeqNum, EndSeq)
      WRITE(12, REC=2) K

c
c    Read/write daily data
c
      K = 0
      DO 301, I = StartSeq, EndSeq
        CALL SEQUENCEDATE(ID, IM, IY, I)
        IF ((IY .GE. SYR) .AND. (IY .LE. EYR)) THEN
           READ(11, REC=(I-StartSeq+1)+2) I1, I2, I3
           K = K+1
           WRITE(12, REC=K+2) I1, I2, I3
        ENDIF
  301 CONTINUE
      CLOSE(11)
      CLOSE(12)
      STOP
      
C
C  FORMATS
C
 1000 FORMAT(A3)
 1001 FORMAT(A4)

      END


c---------------------------------------------------------------------------
      SUBROUTINE ParseCL(CLine, Bsn, CY1, CY2)
      IMPLICIT   NONE
      INTEGER    I, J, St, En
      CHARACTER*3  Bsn
      CHARACTER*4  CY1, CY2
      CHARACTER*80 CLine

      Bsn = 'xxx'
      CY1 = '0000'
      CY2 = '0000'

c
c  Get Basin code
c
      I = 1
      DO WHILE ((CLine(I:I) .EQ. ' ') .AND. (I .LT. 80))
         I = I + 1
      ENDDO
      IF (I .GE. 80) RETURN
      St = I
      J = St + 1
      DO WHILE ((CLine(J:J) .NE. ' ') .AND. (J .LT. 80))
         J = J + 1
      ENDDO
      IF (J .GE. 80) RETURN
      En = J-1
      IF (En .GT. St+2) En = St+2
      Bsn = CLine(St:En)

c
c  Get first year
c
      I = J
      DO WHILE ((CLine(I:I) .EQ. ' ') .AND. (I .LT. 80))
         I = I + 1
      ENDDO
      IF (I .GE. 80) RETURN
      St = I
      J = St + 1
      DO WHILE ((CLine(J:J) .NE. ' ') .AND. (J .LT. 80))
         J = J + 1
      ENDDO
      IF (J .GE. 80) RETURN
      En = J-1
      IF (En .GT. St+3) En = St+3
      CY1 = CLine(St:En)

c
c  Get second year
c
      I = J
      DO WHILE ((CLine(I:I) .EQ. ' ') .AND. (I .LT. 80))
         I = I + 1
      ENDDO
      IF (I .GE. 80) RETURN
      St = I
      J = St + 1
      DO WHILE ((CLine(J:J) .NE. ' ') .AND. (J .LT. 80))
         J = J + 1
      ENDDO
      IF (J .GE. 80) RETURN
      En = J-1
      IF (En .GT. St+3) En = St+3
      CY2 = CLine(St:En)

      END


c---------------------------------------------------------------------------
      SUBROUTINE Caps(String, Chars)
      INTEGER*4  Chars, I
      CHARACTER*(*) String
      
      DO 10, I = 1, Chars
        IF ((String(I:I) .GE. 'a') .AND. (String(I:I) .LE. 'z')) THEN
          String(I:I) = CHAR(ICHAR(String(I:I)) - 32)
        ENDIF
 10   CONTINUE
      RETURN
      END

c---------------------------------------------------------------------------
      SUBROUTINE Small(String, Chars)
      INTEGER*4  Chars, I
      CHARACTER*(*) String
      
      DO 10, I = 1, Chars
        IF ((String(I:I) .GE. 'A') .AND. (String(I:I) .LE. 'Z')) THEN
          String(I:I) = CHAR(ICHAR(String(I:I)) + 32)
        ENDIF
 10   CONTINUE
      RETURN
      END


c---------------------------------------------------------------------------
      SUBROUTINE DateSequence
     &  (Day, Month, Year, SequenceNumber)
c
c     This routine computes the number of the date, with days numbered
c     sequentially from 1 (corresponding to the base date).  The base
c     date must be 1 March on any LEAP YEAR or century boundary. Dates
c     must be between the base date and the base date plus 2,147,483,646.
c     This routine is set up to use only 4-byte integer variables and 
c     to avoid intermediate use of reals in the evaluation of expressions.
c     It is a modification of the previous version which used 2-byte integer
c     variables. For reference on the 2-byte version of this subroutine
c     see Dr. Dobb's Journal 80:66-70.  Adapted by Tim Hunter.
c
      IMPLICIT NONE
      INTEGER*4 BaseYear
      PARAMETER (BaseYear = 0)
      INTEGER*4 NumYears, TotC, LeapC, SkipC, NonLeapC
      INTEGER*4 Day, Month, Year, SequenceNumber
      IF (Year .LE. BaseYear) STOP 'Year .LE. BaseYear'
      NumYears = Year - BaseYear - 1 + (Month + 9) / 12
      TotC = (BaseYear + NumYears)/100 - (BaseYear/100)
      SkipC = 3 - MOD(BaseYear/100, 4)
      LeapC = (TotC + 3 - SkipC) / 4
      NonLeapC = TotC - LeapC
      SequenceNumber = 365 * NumYears + (NumYears/4) - NonLeapC
     &                + (153 * MOD(Month + 9, 12) + 2) / 5 + Day 
      RETURN
      END

c-------------------------------------------------------------------------
      SUBROUTINE SequenceDate
     &  (Day, Mon, Year, SequenceNumber)
c
c     This routine computes the date of the number, with days numbered
c     sequentially from 1 (corresponding to the base date).  The base date must
c     be 1 March of any year divisible by 4 (i.e. leap years and century years).
c     The base year must be greater than or equal to 0.  Dates must be between
c     the base date and the base date plus 2,147,483,636. This routine is set 
c     up to use 4-byte integer variables and to avoid intermediate use of reals 
c     in the evaluation of expressions. Adapted from Dr. Dobb's Journal 80:66-70
c     by Tim Hunter.
c
c
      IMPLICIT   NONE
      INTEGER*4  Day,Mon,Year, SequenceNumber, SeqNum, CentDays, BY

      SeqNum = SequenceNumber
      BY = 0                          ! start in 0 A.D. 

c
c  Century Computations
c
      CentDays = 36524                ! since 100 A.D. is not a leap year
      DO WHILE (SeqNum .GT. CentDays)
         BY = BY + 100
         SeqNum = SeqNum - CentDays
         CentDays = 36524
         IF (((BY+100)/400*400) .EQ. (BY+100)) CentDays = 36525
      ENDDO

c
c  At this point, SeqNum is less than 100 years.  The following code is
c  identical to the original 2-byte version.
c
      Year = (SeqNum - 1 - SeqNum/1461) / 365
      Day  = SeqNum - 365*Year - Year/4
      Mon  = MOD ((5*Day - 3)/153 + 2, 12) + 1
      Year = Year + BY + 1 - (Mon+9)/12
      Day  = Day - (153 * MOD(Mon+9, 12) + 2) / 5

      RETURN
      END


